transform (ccPage);

var app = null;

function transform(ScriptHelperObj) {

  var page;
  // get contextObject from IScriptHelper
  var collection = ScriptHelperObj.contextObject;

  // get application  
  app     = collection.Item(1);
  // get package XML DOM document
  var package = collection.Item(2);

  // to do: add your code here
  //----------------------------
var newDateObj = new Date();
var before = newDateObj.getSeconds()*1000 + newDateObj.getMilliseconds();

var programmingLanguage = package.selectSingleNode("/Package/Site/@language").nodeTypedValue;
addEmptyControlPoints(package);

if (programmingLanguage == "ASPTemplates" ||
    programmingLanguage == "C#" ||
    programmingLanguage == "CFML" ||
    programmingLanguage == "CFMLTemplates" ||
    programmingLanguage == "JSP" ||
    programmingLanguage == "PerlTemplates" ||
    programmingLanguage == "PHPTemplates" ||
    programmingLanguage == "ServletTemplates" ||
    programmingLanguage == "VB")
      addPageEvents(package);

//newDateObj = new Date();
//var after = newDateObj.getSeconds()*1000 + newDateObj.getMilliseconds();
//app.MessagesWindow.addLogEntry(2, "transformOM from " + before + " to " + after);
  
  var fso = app.CCFileSystem;

  var errHTML=app.translations.resourceString("Translation_Item_HTML_Not_Exist");
  var errValue=app.translations.resourceString("Translation_Item_Not_Exist");
  var projectPath=String(app.project.path);
  var pos = projectPath.lastIndexOf("\\"+app.project.name+".ccs");
  if (pos>0) projectPath = projectPath.substr(0,pos+1);

  var lang = package.selectSingleNode("/Package/Site/@siteLanguage").nodeTypedValue;
  var langDef = app.project.Resources.Languages.ItemByLangId(lang);
  if (langDef==null) return;
  var languages = app.project.Resources.Languages;
  var langIDs=new Array();
  for (var l = 1;l<=languages.Count;l++)
  {  
  	var country = languages.Item(l).countryID.toUpperCase();
	var lid = languages.Item(l).LanguageID.toLowerCase();
  	if (country!="") lid = lid.concat("-", lid);
	langIDs[langIDs.length] = lid;
  }


  errHTML = errHTML.replace("{1}", langDef.LanguageName);
  errValue = errValue.replace("{3}", langDef.LanguageName);

   var vars;
   var re = /{res:([A-z0-9\-_]+)}/g;
   page = app.project.ExecCommand(113, 1, 0, 0); 
   if(page != null) {
   	var s = page.templateContent(true);
   	while((vars = re.exec(s)) != null){ 
      		checkKey(vars[1], "", null,langDef,errHTML);
      		s = s.replace(vars[1],"");
     	}
   }
   delete fso;
   fso = null;

}

function addEmptyControlPoints(doc) {
    function newId() {
        var res = 0;
        var nodes = doc.selectNodes("//*[@id]/@id");
        for (var i = 0; i < nodes.length; i++)
            if (!isNaN(nodes[i].text))
                res = Math.max(res, parseInt(nodes[i].text));
        return res + 1;
    }
    var features = doc.selectNodes("//Features/*");
    for (var i = 0; i < features.length; i++) {
        var feature = features[i];
        var controlPoints = feature.selectSingleNode("ControlPoints");
        var featureName = feature.nodeName;
        var properties = app.project._schema(featureName).properties;
        for (var k = 1; k <= properties.Count; k++)
            if (properties.Item(k).getProperty("controlPoint") == "True") {
                var prop = properties.Item(k).Name;
                var cpStr = feature.getAttribute(prop);
                if (!cpStr)
                    break;
                var cPoints = cpStr.split(";");
                for (var j = 0; j < cPoints.length; j++) {
                    var cPoint = cPoints[j];
                    cPoint = cPoint.replace(/ /g, "");
                    if (cPoint.indexOf(".") != -1 && !feature.selectSingleNode(".//ControlPoint[@name='" + cPoint + "']")) {
                        var controlPoint = doc.createElement("ControlPoint");
                        controlPoint.setAttribute("id", newId());
                        controlPoint.setAttribute("name", cPoint);
                        controlPoint.setAttribute("relProperty", prop);
                        controlPoint.appendChild(doc.createElement("Items"));
                        controlPoints.appendChild(controlPoint);
                    }
                }
            }
    }
}

//----------------------------
function checkKey(key, prop, node,langDef,errHTML){
	var lkey=key.toLowerCase();
	if (lkey == "ccs_formatinfo" || lkey == "ccs_localeid" || lkey == "ccs_languageid") return;
	var text="";
	if (!langDef.Translations.KeyExists(key)){
		if (node == null){
			text =  errHTML;
       		} else {
       			text = errValue;
       			var ctrl=node.selectSingleNode("../@name").nodeTypedValue;
       			text=text.replace("{2}",ctrl).replace("{1}",prop);
		}
		app.MessagesWindow.addLogEntry(2,text.replace("{0}",key));
	}
}
   
// --------------------- Features code

function addPageEvents(newDoc) {
	var features = newDoc.selectNodes("//Features/*|//Components/*");
	for (var i = 0; i < features.length; i++) {
		var feature = features.item(i);
		var featureName = feature.nodeName;
		var featureEvents = getFeatureEvents(featureName);
		var control = feature;                                              	
		if (control.parentNode.nodeName == "Features") {
			control = control.parentNode.parentNode;
		}
		var form = getFeatureContainer(feature, true);
		var container = getFeatureContainer(feature, false);
		var page = newDoc.selectSingleNode('.//Components/Page');
		if (feature.getAttribute("enabled") != "False") {
			addControlEvents(control, featureEvents, "Control");
			addControlEvents(page, featureEvents, "Page");
			addControlEvents(form, featureEvents, "Form");
			addControlEvents(container, featureEvents, "Container");
		}
	}
}

function addControlEvents(control, featureEvents, objectType) {
	var newDoc = control.ownerDocument;
	for (var j = 0; j < featureEvents.length; j++) {
		if (featureEvents[j].object == objectType) {
			var eventName = featureEvents[j].name;
			var eventType = featureEvents[j].type;
			var events = control.selectSingleNode("Events");
			var existingEvents = events.selectNodes("Event[@name = '" + eventName + "' and @type = '" + eventType + "']");
			var newEvent = null;
			if (existingEvents.length == 0) {
				var newEvent = newDoc.createElement("Event");
				newEvent.setAttribute("name", eventName);
				newEvent.setAttribute("type", eventType);
				events.appendChild(newEvent);
				var newActions = newDoc.createElement("Actions");
				newEvent.appendChild(newActions);
				var newAction = newDoc.createElement("Action");
				newAction.setAttribute("actionName", "Bind Feature");
				newAction.setAttribute("actionCategory", "General");
				newAction.setAttribute('id', Math.round(Math.random()*100)+100); // Or maybe no id
				newActions.appendChild(newAction);
			}
		}
	}
}                

var featureEvents;

function getFeatureEvents(featureName) {
	if (featureEvents == null) {
	 	featureEvents = [];
	}
	if (featureEvents[featureName]) {
	 	return featureEvents[featureName];
	}
	var domPath = app.project._schema(featureName).schemaPath;
	var domModel = new ActiveXObject("MSXML2.DOMDocument");
	domModel.load(domPath);
	var usedEvents = domModel.selectNodes("//UsedEvent");
	var resultEvents = [];
	for (var i = 0; i < usedEvents.length; i++) {
		var currentEvent = usedEvents[i];
		resultEvents[resultEvents.length] = {"name": currentEvent.getAttribute("name"), "type": currentEvent.getAttribute("type"), "object": currentEvent.getAttribute("object")};
	}
	featureEvents[featureName] = resultEvents;
	return resultEvents;
}

function getFeatureContainer(controlNode, formOnly) {
    while (true) {
        if (controlNode != null && controlNode.nodeName != 'Page') {
            if (controlNode.nodeName != 'Features' && controlNode.nodeName != 'Components') {
                if (getSchemaProperty(controlNode, "type") == "Container") {
                    if (!formOnly || getSchemaProperty(controlNode, "transparent") != "True") {
                        break;
                    }
                }
            }
	    controlNode = controlNode.parentNode;
        } else {
            break;
        }
    }
    return controlNode;
}

var propertiesCache;

function getSchemaProperty(node, propertyName) {
     if (propertiesCache == null) {
     	propertiesCache = [];
     }
     if (propertiesCache[node.nodeName] && propertiesCache[node.nodeName][propertyName]) {
     	return propertiesCache[node.nodeName][propertyName];
     }
     var domPath = app.project._schema(node.nodeName).schemaPath;
     var domModel = new ActiveXObject("MSXML2.DOMDocument");
     domModel.load(domPath);
     var result = domModel.documentElement.getAttribute(propertyName);
     domModel = null;
     if (!propertiesCache[node.nodeName]) {
      	propertiesCache[node.nodeName] = [];
     }
     propertiesCache[node.nodeName][propertyName] = result;
     return result;
}




